
#property link      " "

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Red
#property indicator_color5 DodgerBlue
#property indicator_color6 Red

extern double Risk     = 0.3;
extern int EnableAlert = 0;
extern int SndMail     = 0;
int Begin   = 9;
int Cond1   = 1;
int Cond2   = 1;
int BarsNr  = 1000;

double UpStop[];
double DnStop[];
double UpSign[];
double DnSign[];
double UpLine[];
double DnLine[];
double WorkBu[];

bool BuFlag = FALSE;
bool SeFlag = FALSE;

int init() {
   IndicatorBuffers(7);
   SetIndexBuffer(0, UpStop); SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 159); SetIndexLabel(0, "UpTrend Stop");
   SetIndexBuffer(1, DnStop); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 159); SetIndexLabel(1, "DownTrend Stop");
   SetIndexBuffer(2, UpSign); SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 108); SetIndexLabel(2, "UpTrend Signal");
   SetIndexBuffer(3, DnSign); SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 108); SetIndexLabel(3, "DownTrend Signal");
   SetIndexBuffer(4, UpLine); SetIndexStyle(4, DRAW_LINE);                         SetIndexLabel(4, "UpTrend Line"); 
   SetIndexBuffer(5, DnLine); SetIndexStyle(5, DRAW_LINE);                         SetIndexLabel(5, "DownTrend Line"); 
   SetIndexBuffer(6, WorkBu);                               
   
   SetIndexDrawBegin(0, Begin);
   SetIndexDrawBegin(1, Begin);
   SetIndexDrawBegin(2, Begin);
   SetIndexDrawBegin(3, Begin);
   SetIndexDrawBegin(4, Begin);
   SetIndexDrawBegin(5, Begin);   
   
   string ShName = "WealthIndicator";
   IndicatorShortName(ShName);

   return (0);
}

int start() {
   double Hi;
   double Lo;
   double Var_1;
   double Hi_Arr[5000];
   double Lo_Arr[5000];
   double Med_Hi[5000];
   double Med_Lo[5000];
   string Alrt1;
   for (int i = BarsNr - 1; i >= 0; i--) {
      UpStop[i] = EMPTY_VALUE;
      DnStop[i] = EMPTY_VALUE;
      UpSign[i] = -1;
      DnSign[i] = -1;
      UpLine[i] = EMPTY_VALUE;
      DnLine[i] = EMPTY_VALUE;
      WorkBu[i] = 0;
   }
   for (i = BarsNr - Begin - 1; i >= 0; i--) {
      Hi = High[i];
      Lo = Low[i];
      for (int j = i - 1 + Begin; j >= i; j--) {
         Var_1 = High[j];
         if (Hi < Var_1) Hi = Var_1;
         Var_1 = Low[j];
         if (Lo > Var_1) Lo = Var_1;
      }
      Hi_Arr[i] = Hi;
      Lo_Arr[i] = Lo;
      Med_Hi[i] = Hi_Arr[i] - (Hi_Arr[i] - Lo_Arr[i]) * Risk;
      Med_Lo[i] = Lo_Arr[i] + (Hi_Arr[i] - Lo_Arr[i]) * Risk;
      WorkBu[i] = WorkBu[i + 1];
      if (Close[i] > Med_Hi[i + 1]) WorkBu[i] = 1;
      if (Close[i] < Med_Lo[i + 1]) WorkBu[i] = -1;
      if (WorkBu[i] > 0.0 && Med_Lo[i] < Med_Lo[i + 1]) Med_Lo[i] = Med_Lo[i + 1];
      if (WorkBu[i] < 0.0 && Med_Hi[i] > Med_Hi[i + 1]) Med_Hi[i] = Med_Hi[i + 1];
      if (WorkBu[i] > 0.0) {
         if (Cond1 > 0 && UpStop[i + 1] == -1.0) {
            UpSign[i] = Med_Lo[i];
            if (Cond2 > 0) UpLine[i] = Med_Lo[i];
            if (EnableAlert > 0 && i == 0) PlaySound("alert2.wav");
         } else {
            UpStop[i] = Med_Lo[i];
            if (Cond2 > 0) UpLine[i] = Med_Lo[i];
            UpSign[i] = -1;
         }
         if (Cond1 == 2) UpStop[i] = 0;
         DnStop[i] = -1.0;
         DnLine[i] = EMPTY_VALUE;
      }
      if (WorkBu[i] < 0.0) {
         if (Cond1 > 0 && DnStop[i + 1] == -1.0) {
            DnSign[i] = Med_Hi[i];
            if (Cond2 > 0) DnLine[i] = Med_Hi[i];
            if (EnableAlert > 0 && i == 0) PlaySound("alert2.wav");
         } else {
            DnStop[i] = Med_Hi[i];
            if (Cond2 > 0) DnLine[i] = Med_Hi[i];
            DnSign[i] = -1;
         }
         if (Cond1 == 2) DnStop[i] = 0;
         UpStop[i] = -1.0;
         UpLine[i] = EMPTY_VALUE;
      }
      if (WorkBu[2] < 0.0 && WorkBu[1] > 0.0 && Volume[0] > 1.0 && (!BuFlag)) {
         Alrt1 = " " + Symbol() + " M" + Period() + ": BUY SIGNAL";
         if (EnableAlert > 0) Alert(Alrt1);
         if (SndMail > 0) SendMail("FxChampion Signal", TimeToStr(TimeCurrent()) + Alrt1);
         BuFlag = TRUE;
         SeFlag = FALSE;
      }
      if (WorkBu[2] > 0.0 && WorkBu[1] < 0.0 && Volume[0] > 1.0 && (!SeFlag)) {
         Alrt1 = " " + Symbol() + " M" + Period() + ": SELL SIGNAL";
         if (EnableAlert > 0) Alert(Alrt1);
         if (SndMail > 0) SendMail("FxChampion Signal", TimeToStr(TimeCurrent()) + Alrt1);
         SeFlag = TRUE;
         BuFlag = FALSE;
      }
   }
   return (0);
}